unit Az1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, COMAPI, ExtCtrls, Receive;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type tPort=(pCOM1,pCOM2);
var
  Form1: TForm1;
  INIFIL:TIniFile;
  COMName:string;
  pCOMName:PChar;
  Baud:integer;
  Zero:integer;
  Signed:boolean=false;
  FIG:string[3];
  EVMask:DWORD;
  RX:TReceive;
  New:boolean;

implementation

{$R *.dfm}

var BadNews:string;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 RX.Free;
 CloseCOM;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 INIFIL:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.INI'));
 BadNews:=#10#13+'  '+INIFIL.FileName
         +#10#13+'  ';
 with INIFIL do begin
  Zero:=(ReadInteger('Settings','Zero',0) mod 360)-360;
  Signed:=(ReadString('Settings','Signed','NO')='YES');
  COMName:=ReadString('Settings','Port','COM1');
  if not((copy(COMName,1,3)='COM')
          and (COMName[4] in ['1'..'8'])
          and (Length(COMName)=4))
  then begin
   Showmessage('    '+COMName+BadNews);
   Application.Free;
  end else
  Baud:=ReadInteger('Settings','Baud',1200);
  if (Baud<>CBR_1200)
  and (Baud<>CBR_2400)
  and (Baud<>CBR_4800)
  and (Baud<>CBR_9600)
  then begin
   ShowMessage('    '+IntToStr(Baud)+' '
   +BadNews);
   Application.Free;
  end;
  Free;
 end;
 if OpenCOM(PChar(COMName))
 then Form1.Caption:=' ('+COMName+')'
 else begin
  ShowMessage('    '+COMName+BadNews);
  Application.Free;
 end;
 SetCOMBuff(2048,2048);
 SetCOM(Baud,8,NOPARITY,ONESTOPBIT);
 PurgeCOM;
 RX:=TReceive.Create(false);
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if not New then Form1.Label1.Caption:='OFF';
 New:=false;
end;

end.

