unit COMAPI;
interface
uses Windows;
var hCom:tHANDLE;
    DCB:tDCB;
    ComTo:tCOMMTIMEOUTS;
    EvtMask:DWORD;

function AccessCOM(Port:PChar):Boolean;stdcall;

function OpenCOM(Port:PChar):Boolean;stdcall;

function CloseCOM:Boolean;stdcall;

function SetCOM(Baud:cardinal;BSize,Par,SBits:byte):boolean;stdcall;

function SetModCOM(Baud:cardinal;BSize,Par,SBits:byte;
                   DTR,RTS:boolean):boolean;stdcall;

function SetCOMTo(RdIvl,RdTotM,RdTotC,WrTotM,WrTotC:cardinal):boolean;stdcall;

function SetCOMBuff(RdBuff,WrBuff:cardinal):boolean;stdcall;

function EscFuncCOM (f:cardinal):boolean;stdcall;

function GetModem(var lpD:cardinal):boolean;stdcall;

function PurgeCOM:boolean;stdcall;

function FlushCOM:boolean;stdcall;

function TxByteCOM(var data:byte):boolean;stdcall;

function TxDataCOM(const Buff;n:cardinal;var lpNDone:cardinal):boolean;stdcall;

function RxDataCOM(var Buff;n:cardinal;var lpNDone:cardinal):boolean;stdcall;

function ClrErrCOM (var lpE:cardinal):boolean;stdcall;

function GetMaskCOM(var EvtMask:cardinal):boolean;stdcall;

function SetMaskCOM(EvtMask:cardinal):boolean;stdcall;

function WaitEventCOM(var EvtMask:cardinal):boolean;stdcall;

implementation

function AccessCOM(Port:PChar):boolean;stdcall;
var hTemp: tHANDLE;
begin
 hTemp:=CreateFile(Port,GENERIC_READ or GENERIC_WRITE,0,nil,
                   OPEN_EXISTING,0,0);
 if not(hTemp=INVALID_HANDLE_VALUE)
 then begin
  CloseHandle(hTemp);
  Result:=true;
 end else Result:=false;
end;

function OpenCOM(Port:PChar):boolean;stdcall;
begin
 hCom:= CreateFile(Port,GENERIC_READ or GENERIC_WRITE,0,nil,
                   OPEN_EXISTING,0,0);
 if (hCom=INVALID_HANDLE_VALUE)
 then begin
  Result:=false;
  exit;
 end;
 if not GetCommState(hCom,dcb)
 then begin
  Result:=false;
  exit;
 end;
 if not GetCommTimeouts(hCom,ComTo)
 then begin
  Result:=false;
  exit;
 end;
 Result:=true;
end;

function CloseCOM:boolean; stdcall;
begin
 Result:=CloseHandle(hCom);
end;

function SetCOM(Baud:DWORD;BSize,Par,SBits:byte):boolean; stdcall;
begin
 with DCB do begin
  BaudRate:=Baud;
  Flags:=$00000001;
  ByteSize:=BSize;
  Parity:=Par;
  StopBits:=SBits;
 end;
 Result:=SetCommState(hCom,DCB);
end;

function SetModCOM(Baud:DWORD;BSize,Par,SBits:byte;DTR,RTS:boolean):boolean;stdcall;
begin
 with DCB do begin
  BaudRate:=Baud;
  Flags:=$00000001;
  if DTR then Flags:=Flags or $00000010;
  if RTS then Flags:=Flags or $00001000;
  ByteSize:=BSize;
  Parity:=Par;
  StopBits:=sbits;
 end;
 Result:=SetCommState(hCom,dcb);
end;

function SetCOMTo(RdIvl,RdTotM,RdTotC,WrTotM,WrTotC:DWORD):boolean; stdcall;
begin
 with ComTo do begin
  ReadIntervalTimeout:=RdIvl;
  ReadTotalTimeoutMultiplier:=RdTotM;
  ReadTotalTimeoutConstant:=RdTotC;
  WriteTotalTimeoutMultiplier:=WrTotM;
  WriteTotalTimeoutConstant:=WrTotC;
 end;
 Result:=SetCommTimeouts(hCom,ComTo);
end;

function SetCOMBuff(RdBuff,WrBuff:DWORD):boolean;stdcall;
begin
 Result:=SetupComm(hCom,RdBuff,WrBuff);
end;

function EscFuncCOM(F:DWORD):boolean;stdcall;
begin
 Result:=EscapeCommFunction(hCom,F)
end;

function GetModem(var lpD:DWORD):boolean;stdcall;
begin
 Result:=GetCommModemStatus(hCom,lpD);
end;

function PurgeCOM:boolean;stdcall;
begin
 Result:=PurgeComm(hCom,PURGE_TXABORT
                     or PURGE_RXABORT
                     or PURGE_TXCLEAR
                     or PURGE_RXCLEAR);
end;

function FlushCOM:boolean; stdcall;
begin
 Result:=FlushFileBuffers(hCom);
end;

function TxByteCOM(var data:byte):boolean;stdcall;
begin
 Result:=TransmitCommChar(hCom,Chr(data));
end;

function TxDataCOM(const Buff;N:DWORD;var lpNDone:DWORD):boolean;stdcall;
begin
  Result:=WriteFile(hCom,Buff,N,lpNDone,nil);
end;

function RxDataCOM(var Buff;N:DWORD;var lpNDone:DWORD):boolean;stdcall;
begin
  Result:=ReadFile(hCom,Buff,N,lpNDone,nil);
end;

function ClrErrCOM(var lpE:DWORD):boolean;stdcall;
begin
  Result:=ClearCommError(hCom,lpE,nil);
end;

function GetMaskCOM(var EvtMask:DWORD):boolean;stdcall;
begin
  Result:=GetCommMask(hCom,EvtMask);
end;

function SetMaskCOM(EvtMask:DWORD):boolean;stdcall;
begin
  Result:=SetCommMask(hCom,EvtMask);
end;

function WaitEventCOM(var EvtMask:DWORD):boolean;stdcall;
begin
  Result:=WaitCommEvent(hCom,EvtMask,nil);
end;

end.
