	ERRORLEVEL 1
	#include <P16F628.inc>
	
M360	EQU	.360*8	
ZERO	EQU	0
	
	NOLIST	
;=========================================
; 16-   
add16c	macro	L,H,c
	movlw	Low(c)
	addwf	L,f
	btfsc	STATUS,C
	incf	H,f
	movlw	High(c)
	addwf	H,f
	endm
;=========================================
;   UART
WaitTXRdy	macro
	local	L
	nop
L	btfss	PIR1,TXIF
	goto	L
	bcf	PIR1,TXIF
	endm
;=========================================
;  EEPROM	
Wr_EE	macro	D, A
	clrwdt
	movf	D,w
	bsf	STATUS,RP0
	movwf	EEDATA
	movlw	Low(A)
	movwf	EEADR
	call	EE_WR
	endm
	
	LIST
;====================================
	__CONFIG _MCLRE_OFF & _WDT_ON  & _INTRC_OSC_CLKOUT & _LVP_OFF & _PWRTE_ON & _BODEN_ON	
;====================================
;PORT B ()
bPhA	EQU	4	;RB7, . 10
bPhB	EQU	5	;RB6, . 11
bPhC	EQU	6	;RB5, . 12
;PORT B ()
bX1	EQU	7	;RB4, . 13
;PORT A ( )
bRot	EQU	0	;AN0, . 17
bRef	EQU	2	;AN2, . 1
;PORT A ( )
bCMP1	EQU	3	;AN3, . 2
bCMP2	EQU	4	;AN4, . 3 
;
mPhA	EQU	1<<bPhA
mPhB	EQU	1<<bPhB
mPhC	EQU	1<<bPhC
m3F	EQU	mPhA+mPhB+mPhC
mRot	EQU	1<<bRot
; PSF
bNew	EQU	0	;  
bOfl	EQU	1	;  
bOldX1	EQU	2	; X1   
;==================================	
	CBLOCK	H'20'
	PSF	; 
	IntCtr	; 
	Phase	; 
	BL
	BH
	AL	;
	AH	;
	ZrH
	TMP
	A100	; 
	A10	; 
	A1	; 
	W_save	; W
	ST_save	; STATUS
	endc
;================================	
	goto START
;================================	
	ORG 4
INTSERV	; 
	clrwdt
	movwf	W_save	; W
	movf	STATUS,w	; 
	movwf	ST_save
	btfss	INTCON,T0IF	;  TMR0?
	goto	T2
	bcf	INTCON,T0IF	;.  
	nop
	movlw	D'18'		; 
	addwf	TMR0,f
	movf	TMR0,f
	movf	Phase,w
	call	NewOut	; 	
	movwf	PORTB		; 
	decfsz	Phase,f		; ?
	goto	T20		
	clrf	TMR1H		;.   
	clrf	TMR1L
	movlw	6		;  .
	movwf	Phase
T20	incfsz	IntCtr,f	; 	
	goto	T2
	bsf	PSF,bOfl	; 
T2	btfss	PIR1,CCP1IF	;  CCP1?
	goto	T3
	bcf	PIR1,CCP1IF	;.  
	btfss	PSF,bOfl	;  ?
	goto	T3
	movf	CCPR1L,w	;,   
	movwf	BL
	movf	CCPR1H,w
	movwf	BH
	bsf	PSF,bNew	;  
	bcf	PSF,bOfl	;   
T3	movf	ST_save,w	; 
	movwf	STATUS
	movf	W_save,w
	retfie
;=========================					
NewOut  addwf	PCL,f
	retlw			 mPhC
	retlw	mPhA		+mPhC
	retlw	mPhA
	retlw	mPhA	+mPhB
	retlw		 mPhB
	retlw		 mPhB	+mPhC
	retlw	  		 mPhC
	retlw	mPhA		+mPhC
;=========================	
START	clrf	PORTB
	clrf	RCSTA
	bsf	RCSTA,SPEN	; USART; 	
	bsf	STATUS,RP0
	clrf	TXSTA
	bcf	TXSTA,BRGH	;1/64
	movlw	.51		; 1200
	movwf	SPBRG
	bsf	TXSTA,TXEN	; 
	clrf 	OPTION_REG	; TMR0 1:2
	movlw	7		;ROT  
	movwf	TRISA
	movlw	~m3F
	movwf	TRISB		;   
	bcf	STATUS,RP0
	movlw	6		;   
	movwf	CMCON
	clrf	T1CON		;TMR1   
	bsf	T1CON,TMR1ON
	movlw	6		; 
	movwf	Phase
	movlw	5		;  
	movwf	CCP1CON
	clrf	PSF		;  
	bsf	STATUS,RP0	; :
	bsf	PIE1,CCP1IE	; CCP1,
	bcf	STATUS,RP0
	bsf	INTCON,PEIE	;  ,
	bsf	INTCON,T0IE	; TMR0
	bsf	INTCON,GIE	; 	
;	
Loop	btfss	PSF,bNew	;  
	goto 	Loop
	movf	BL,w
	movwf	AL
	movf	BH,w
	movwf	AH
	bcf	PSF,bNew
	btfss	PORTB,bX1
	goto	X1_0
	bsf	PSF,bOldX1
	goto	X1_1
X1_0	btfss	PSF,bOldX1
	goto	X1_1
	bcf	PSF,bOldX1
	Wr_EE	AH,ZH		;	
Loop2   btfss	PSF,bNew
	goto	Loop2
	bcf	PSF,bNew	
	Wr_EE	AL,ZL
	goto	Loop		;   
X1_1	add16c	AL,AH,-M360
	movlw	Low(ZH)		; ""  EEPROM
	call	EE_RD
	movwf	ZrH
	movlw	Low(ZL)
	call	EE_RD
	subwf	AL,f		;A=A-Zr	
	btfss	STATUS, C
	decf	AH,f
	movf	ZrH,w
	subwf	AH,f
	movlw	4
	movwf	TMP
LAB0	btfss	AH,7		;while A<0 do A=A+M360
    	goto	LAB1		;A>=0
    	add16c	AL,AH,M360	
    	decfsz	TMP,f
    	goto	LAB0
LAB1	bcf	STATUS,C	;   8
	rrf	AH,f
	btfsc	STATUS,C
	incf	AL,f
	rrf	AL,f
	bcf	STATUS,C
	rrf	AH,f
	btfsc	STATUS,C
	incf	AL,f
	rrf	AL,f
	bcf	STATUS,C
	rrf	AH,f
	btfsc	STATUS,C
	incf	AL,f
	rrf	AL,f
	call BIN2DEC3	;   . 
	WaitTXRdy		;  
	movf	A100,w	;   
	addlw	'0'
	movwf	TXREG
	WaitTXRdy		;   
	movf	A10,w		;   		
	addlw	'0'
	movwf	TXREG
	WaitTXRdy		;  
	movf	A1,w		;   
	addlw	'0'
	movwf	TXREG
	WaitTXRdy		;   
	movlw	0x0D		;   
	movwf	TXREG
	goto	Loop
;=========================		
BIN2DEC3			;  
	clrf	A1		;   
	clrf	A10
	clrf	A100
CV100	add16c	AL,AH,-.100
	incf	A100,f
	btfsc	STATUS,C
	goto	CV100
	add16c	AL,AH,.100
	decf	A100,f
CV10	add16c	AL,AH,-.10
	incf	A10,f
	btfsc	STATUS,C
	goto	CV10
	add16c	AL,AH,.10
	decf	A10,f
	movf	AL,w
	movwf	A1
	return
;======================================	
EE_RD	; EEPROM: 
;	  w - ;
;	 w - .
	bsf	STATUS,RP0
	movwf	EEADR
	bsf	EECON1,RD
	movf	EEDATA,w
	bcf	STATUS,RP0
	return
;=======================================
EE_WR	bsf	STATUS,RP0
	bsf	EECON1,WREN 	; 
	bcf	INTCON,GIE
	movlw	0x55
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1,WR
	bsf	INTCON,GIE
	bcf	EECON1,WREN
	bcf	STATUS,RP0
EE_1	btfss	PIR1,EEIF	; 
	goto	EE_1		;
	bcf	PIR1,EEIF
	return
;======================================	
	org	0x2104		;EEPROM
ZL	DE	Low(ZERO)
ZH	DE	High(ZERO)
;======================================	
	end
